blob: 624dce35168f3f34584742466fe1406855f8d241 [file] [log] [blame]
garciadeblas16304ba2016-05-11 14:47:39 +02001#!/bin/bash
2
3##
4# Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5# This file is part of openmano
6# All Rights Reserved.
7#
8# Licensed under the Apache License, Version 2.0 (the "License"); you may
9# not use this file except in compliance with the License. You may obtain
10# a copy of the License at
11#
12# http://www.apache.org/licenses/LICENSE-2.0
13#
14# Unless required by applicable law or agreed to in writing, software
15# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17# License for the specific language governing permissions and limitations
18# under the License.
19#
20# For those usages not covered by the Apache License, Version 2.0 please
21# contact with: nfvlabs@tid.es
22##
23
tierno76841842016-09-27 09:18:28 +000024#ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
garciadeblas16304ba2016-05-11 14:47:39 +020025#Get needed packages, source code and configure to run openmano
26#Ask for database user and password if not provided
garciadeblas16304ba2016-05-11 14:47:39 +020027
28function usage(){
tiernoc50e5da2016-07-06 17:49:45 +020029 echo -e "usage: sudo $0 [OPTIONS]"
tierno45a52852016-08-26 14:39:42 +020030 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
tiernoc50e5da2016-07-06 17:49:45 +020032 echo -e " OPTIONS"
tierno45a52852016-08-26 14:39:42 +020033 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
garciadeblas89b3d842016-09-19 15:18:33 +020035 echo -e " -q --quiet: install in unattended mode"
tierno45a52852016-08-26 14:39:42 +020036 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
tierno26777652016-11-15 17:33:13 +000038 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
tierno80fde982017-04-26 14:33:25 +020039 echo -e " --updatedb: do not reinstall mano_db DB if it exists, just update database"
tierno443c84a2017-04-24 12:31:33 +020040 echo -e " --force: makes idenpotent, delete previous installations folders if needed. It assumes --updatedb if --forcedb option is not provided"
garciadeblas89b3d842016-09-19 15:18:33 +020041 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
tierno76841842016-09-27 09:18:28 +000042 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
garciadeblas5b1a6642017-04-18 10:10:31 +020043 echo -e " --no-db: do not install mysql server"
garciadeblas16304ba2016-05-11 14:47:39 +020044}
45
46function install_packages(){
47 [ -x /usr/bin/apt-get ] && apt-get install -y $*
tiernoc50e5da2016-07-06 17:49:45 +020048 [ -x /usr/bin/yum ] && yum install -y $*
garciadeblas16304ba2016-05-11 14:47:39 +020049
50 #check properly installed
51 for PACKAGE in $*
52 do
53 PACKAGE_INSTALLED="no"
54 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
55 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
56 if [ "$PACKAGE_INSTALLED" = "no" ]
57 then
tiernoc50e5da2016-07-06 17:49:45 +020058 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
garciadeblas89b3d842016-09-19 15:18:33 +020059 exit 1
garciadeblas16304ba2016-05-11 14:47:39 +020060 fi
61 done
62}
63
tierno80fde982017-04-26 14:33:25 +020064function ask_user(){
65 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
66 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
67 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
68 read -e -p "$1" USER_CONFIRMATION
69 while true ; do
70 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
71 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
72 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
73 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
74 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
75 done
76}
77
tierno45a52852016-08-26 14:39:42 +020078GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
garciadeblasc53ebfa2017-03-31 16:02:13 +020079GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git
tiernoc50e5da2016-07-06 17:49:45 +020080DBUSER="root"
81DBPASSWD=""
82DBPASSWD_PARAM=""
83QUIET_MODE=""
tierno45a52852016-08-26 14:39:42 +020084DEVELOP=""
tierno443c84a2017-04-24 12:31:33 +020085DB_FORCE_UPDATE=""
86UPDATEDB=""
tierno26777652016-11-15 17:33:13 +000087FORCE=""
garciadeblas89b3d842016-09-19 15:18:33 +020088NOCLONE=""
tierno76841842016-09-27 09:18:28 +000089NO_PACKAGES=""
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +030090NO_DB=""
tierno80fde982017-04-26 14:33:25 +020091
tiernoc50e5da2016-07-06 17:49:45 +020092while getopts ":u:p:hiq-:" o; do
93 case "${o}" in
94 u)
95 export DBUSER="$OPTARG"
96 ;;
97 p)
98 export DBPASSWD="$OPTARG"
99 export DBPASSWD_PARAM="-p$OPTARG"
100 ;;
101 q)
102 export QUIET_MODE=yes
103 export DEBIAN_FRONTEND=noninteractive
104 ;;
105 h)
106 usage && exit 0
107 ;;
108 -)
109 [ "${OPTARG}" == "help" ] && usage && exit 0
tierno45a52852016-08-26 14:39:42 +0200110 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
tierno443c84a2017-04-24 12:31:33 +0200111 [ "${OPTARG}" == "forcedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--forcedb" && continue
112 [ "${OPTARG}" == "updatedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--updatedb" && continue
113 [ "${OPTARG}" == "force" ] && FORCE="y" && continue
garciadeblas89b3d842016-09-19 15:18:33 +0200114 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
tierno45a52852016-08-26 14:39:42 +0200115 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
tierno76841842016-09-27 09:18:28 +0000116 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +0300117 [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue
tierno80fde982017-04-26 14:33:25 +0200118 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
tiernoc50e5da2016-07-06 17:49:45 +0200119 exit 1
tierno80fde982017-04-26 14:33:25 +0200120 ;;
tiernoc50e5da2016-07-06 17:49:45 +0200121 \?)
122 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
123 exit 1
124 ;;
125 :)
126 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
127 exit 1
128 ;;
129 *)
130 usage >&2
garciadeblas89b3d842016-09-19 15:18:33 +0200131 exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200132 ;;
133 esac
134done
garciadeblas16304ba2016-05-11 14:47:39 +0200135
tierno443c84a2017-04-24 12:31:33 +0200136if [ "$DB_FORCE_UPDATE" == "--forcedb--updatedb" ] || [ "$DB_FORCE_UPDATE" == "--updatedb--forcedb" ] ; then
137 echo "Error: options --forcedb and --updatedb are mutually exclusive" >&2
138 exit 1
139elif [ -n "$FORCE" ] && [ -z "$DB_FORCE_UPDATE" ] ; then
140 DB_FORCE_UPDATE="--updatedb"
141fi
142
tiernoc50e5da2016-07-06 17:49:45 +0200143#check root privileges and non a root user behind
garciadeblas89b3d842016-09-19 15:18:33 +0200144[ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200145if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
146then
tierno80fde982017-04-26 14:33:25 +0200147 [[ -z $QUIET_MODE ]] && ! ask_user "Install in the root user (y/N)? " n && echo "Cancelled" && exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200148 export SUDO_USER=root
149fi
garciadeblas16304ba2016-05-11 14:47:39 +0200150
tierno80fde982017-04-26 14:33:25 +0200151# Discover Linux distribution
152# try redhat type
garciadeblas16304ba2016-05-11 14:47:39 +0200153[ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
tierno80fde982017-04-26 14:33:25 +0200154# if not assuming ubuntu type
garciadeblas16304ba2016-05-11 14:47:39 +0200155[ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
156if [ "$_DISTRO" == "Ubuntu" ]
157then
tierno45a52852016-08-26 14:39:42 +0200158 _RELEASE=$(lsb_release -rs)
tierno070e95f2017-05-05 15:55:13 +0200159 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
160 then
tierno80fde982017-04-26 14:33:25 +0200161 [[ -z $QUIET_MODE ]] &&
162 ! ask_user "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)' (y/N)? " n &&
163 echo "Cancelled" && exit 1
tierno45a52852016-08-26 14:39:42 +0200164 _RELEASE = 14
garciadeblas16304ba2016-05-11 14:47:39 +0200165 fi
166elif [ "$_DISTRO" == "CentOS" ]
167then
168 _RELEASE="7"
169 if ! cat /etc/redhat-release | grep -q "7."
170 then
tierno80fde982017-04-26 14:33:25 +0200171 [[ -z $QUIET_MODE ]] &&
172 ! ask_user "WARNING! Not tested CentOS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
173 echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200174 fi
175elif [ "$_DISTRO" == "Red" ]
176then
177 _RELEASE="7"
178 if ! cat /etc/redhat-release | grep -q "7."
179 then
tierno80fde982017-04-26 14:33:25 +0200180 [[ -z $QUIET_MODE ]] &&
181 ! ask_user "WARNING! Not tested Red Hat OS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
182 echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200183 fi
184else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
185 _DISTRO_DISCOVER=$_DISTRO
186 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
187 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
tierno80fde982017-04-26 14:33:25 +0200188 [[ -z $QUIET_MODE ]] &&
189 ! ask_user "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type (y/N)? " n &&
190 echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200191fi
192
tierno26777652016-11-15 17:33:13 +0000193#check if installed as a service
194INSTALL_AS_A_SERVICE=""
195[[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
tierno80fde982017-04-26 14:33:25 +0200196
197# Next operations require knowing BASEFOLDER
tierno26777652016-11-15 17:33:13 +0000198if [[ -z "$NOCLONE" ]]; then
tiernoaa5832d2016-12-07 16:20:25 +0100199 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
tierno070e95f2017-05-05 15:55:13 +0200200 BASEFOLDER=__openmano__${RANDOM}
tiernoaa5832d2016-12-07 16:20:25 +0100201 else
tierno070e95f2017-05-05 15:55:13 +0200202 BASEFOLDER="${PWD}/openmano"
tiernoaa5832d2016-12-07 16:20:25 +0100203 fi
tierno070e95f2017-05-05 15:55:13 +0200204 [[ -n "$FORCE" ]] && rm -rf $BASEFOLDER #make idempotent
tierno26777652016-11-15 17:33:13 +0000205else
tierno070e95f2017-05-05 15:55:13 +0200206 HERE=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
207 BASEFOLDER=$(dirname $HERE)
tierno26777652016-11-15 17:33:13 +0000208fi
garciadeblas16304ba2016-05-11 14:47:39 +0200209
tierno80fde982017-04-26 14:33:25 +0200210if [[ -z "$NO_PACKAGES" ]]
tierno76841842016-09-27 09:18:28 +0000211then
tierno80fde982017-04-26 14:33:25 +0200212 echo -e "\n"\
213 "#################################################################\n"\
214 "##### UPDATE REPOSITORIES #####\n"\
215 "#################################################################"
216 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
garciadeblas16304ba2016-05-11 14:47:39 +0200217
tierno80fde982017-04-26 14:33:25 +0200218 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
219 [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
220 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
221 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
222 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
garciadeblas16304ba2016-05-11 14:47:39 +0200223
tierno80fde982017-04-26 14:33:25 +0200224 echo -e "\n"\
225 "#################################################################\n"\
226 "##### INSTALL REQUIRED PACKAGES #####\n"\
227 "#################################################################"
228 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client"
229 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client"
garciadeblas16304ba2016-05-11 14:47:39 +0200230
tierno80fde982017-04-26 14:33:25 +0200231 echo -e "\n"\
232 "#################################################################\n"\
233 "##### INSTALL PYTHON PACKAGES #####\n"\
234 "#################################################################"
235 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
236 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
237 # The only way to install python-bottle on Centos7 is with easy_install or pip
238 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
garciadeblas16304ba2016-05-11 14:47:39 +0200239
tierno80fde982017-04-26 14:33:25 +0200240 # required for vmware connector TODO move that to separete opt in install script
241 sudo pip install --upgrade pip
242 sudo pip install pyvcloud
243 sudo pip install progressbar
244 sudo pip install prettytable
245 sudo pip install pyvmomi
bayramovfe3f3c92016-10-04 07:53:41 +0400246
tierno80fde982017-04-26 14:33:25 +0200247 # required for AWS connector
248 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto"
249 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exists with this name, or PIP should be used
garciadeblas16304ba2016-05-11 14:47:39 +0200250
tierno80fde982017-04-26 14:33:25 +0200251 # install openstack client needed for using openstack as a VIM
tiernob4c22392017-06-14 12:55:38 +0200252 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient "\
253 "python-neutronclient python-cinderclient python-openstackclient"
254 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install \
255 python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient \
256 python-openstackclient #TODO revise if gcc python-pip is needed
tierno80fde982017-04-26 14:33:25 +0200257fi # [[ -z "$NO_PACKAGES" ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200258
garciadeblas89b3d842016-09-19 15:18:33 +0200259if [[ -z $NOCLONE ]]; then
tierno80fde982017-04-26 14:33:25 +0200260 echo -e "\n"\
261 "#################################################################\n"\
262 "##### DOWNLOAD SOURCE #####\n"\
263 "#################################################################"
tierno070e95f2017-05-05 15:55:13 +0200264 if [[ -d "${BASEFOLDER}" ]] ; then
tierno80fde982017-04-26 14:33:25 +0200265 if [[ -n "$FORCE" ]] ; then
tierno070e95f2017-05-05 15:55:13 +0200266 echo "deleting '${BASEFOLDER}' folder"
267 rm -rf "$BASEFOLDER" #make idempotent
tierno80fde982017-04-26 14:33:25 +0200268 elif [[ -z "$QUIET_MODE" ]] ; then
tierno070e95f2017-05-05 15:55:13 +0200269 ! ask_user "folder '${BASEFOLDER}' exists, overwrite (y/N)? " n && echo "Cancelled!" && exit 1
270 rm -rf "$BASEFOLDER"
tierno80fde982017-04-26 14:33:25 +0200271 else
tierno070e95f2017-05-05 15:55:13 +0200272 echo "'${BASEFOLDER}' folder exists. Use "--force" to overwrite" >&2 && exit 1
tierno80fde982017-04-26 14:33:25 +0200273 fi
274 fi
tierno070e95f2017-05-05 15:55:13 +0200275 su $SUDO_USER -c "git clone ${GIT_URL} ${BASEFOLDER}"
tierno6e8b5a82017-05-26 11:20:48 +0200276 LATEST_STABLE_TAG=`git -C "${BASEFOLDER}" tag -l v[0-9].* | tail -n1`
277 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${BASEFOLDER} checkout tags/${LATEST_STABLE_TAG}"
tierno070e95f2017-05-05 15:55:13 +0200278 su $SUDO_USER -c "cp ${BASEFOLDER}/.gitignore-common ${BASEFOLDER}/.gitignore"
garciadeblas89b3d842016-09-19 15:18:33 +0200279fi
garciadeblas16304ba2016-05-11 14:47:39 +0200280
tierno80fde982017-04-26 14:33:25 +0200281echo -e "\n"\
282 "#################################################################\n"\
283 "##### INSTALLING OVIM LIBRARY #####\n"\
284 "#################################################################"
tierno070e95f2017-05-05 15:55:13 +0200285su $SUDO_USER -c "git -C ${BASEFOLDER} clone ${GIT_OVIM_URL} openvim"
286[[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${BASEFOLDER}/openvim checkout v2.0"
garciadeblase02ee6e2017-04-24 13:01:45 +0200287
garciadeblasc53ebfa2017-03-31 16:02:13 +0200288# Install debian dependencies before setup.py
garciadeblasaa1044b2017-04-21 07:12:17 +0200289[ "$_DISTRO" == "Ubuntu" ] && install_packages "libmysqlclient-dev"
290[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "libmysqlclient-dev" #TODO check if that's the name in CentOS and RedHat
tierno070e95f2017-05-05 15:55:13 +0200291make -C ${BASEFOLDER}/openvim lite
292rm -rf "${BASEFOLDER}/openvim"
garciadeblasd5b5dcc2017-04-21 13:05:56 +0200293OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'`
garciadeblasc53ebfa2017-03-31 16:02:13 +0200294
garciadeblas16304ba2016-05-11 14:47:39 +0200295if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
296then
tierno80fde982017-04-26 14:33:25 +0200297 echo -e "\n"\
298 "#################################################################\n"\
299 "##### CONFIGURE firewalld #####\n"\
300 "#################################################################"
301 if [[ -z $QUIET_MODE ]] || ask_user "Configure firewalld for openmanod port 9090 (Y/n)? " y
garciadeblas16304ba2016-05-11 14:47:39 +0200302 then
303 #Creates a service file for openmano
304 echo '<?xml version="1.0" encoding="utf-8"?>
305<service>
306 <short>openmanod</short>
307 <description>openmanod service</description>
308 <port protocol="tcp" port="9090"/>
309</service>' > /etc/firewalld/services/openmanod.xml
310 #put proper permissions
311 pushd /etc/firewalld/services > /dev/null
312 restorecon openmanod.xml
313 chmod 640 openmanod.xml
314 popd > /dev/null
315 #Add the openmanod service to the default zone permanently and reload the firewall configuration
316 firewall-cmd --permanent --add-service=openmanod > /dev/null
317 firewall-cmd --reload > /dev/null
318 echo "done."
319 else
320 echo "skipping."
321 fi
322fi
323
tierno80fde982017-04-26 14:33:25 +0200324echo -e "\n"\
tierno070e95f2017-05-05 15:55:13 +0200325 "#################################################################\n"\
326 "##### CONFIGURE OPENMANO CLIENT #####\n"\
tierno80fde982017-04-26 14:33:25 +0200327 "#################################################################"
tierno26777652016-11-15 17:33:13 +0000328#creates a link at ~/bin if not configured as a service
329if [[ -z "$INSTALL_AS_A_SERVICE" ]]
tiernoc50e5da2016-07-06 17:49:45 +0200330then
tierno26777652016-11-15 17:33:13 +0000331 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
332 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
333 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
334 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
tierno070e95f2017-05-05 15:55:13 +0200335 su $SUDO_USER -c "ln -s '${BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
336 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
337 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/service-openmano' "'${HOME}/bin/service-openmano'
tierno26777652016-11-15 17:33:13 +0000338
339 #insert /home/<user>/bin in the PATH
tierno80fde982017-04-26 14:33:25 +0200340 #skiped because normally this is done authomatically when ~/bin exists
tierno26777652016-11-15 17:33:13 +0000341 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
342 #then
343 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
344 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
345 #fi
tierno070e95f2017-05-05 15:55:13 +0200346
347 if [[ $SUDO_USER == root ]]
tiernoc50e5da2016-07-06 17:49:45 +0200348 then
tierno26777652016-11-15 17:33:13 +0000349 if ! echo $PATH | grep -q "${HOME}/bin"
350 then
351 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
352 fi
tierno070e95f2017-05-05 15:55:13 +0200353 fi
tierno26777652016-11-15 17:33:13 +0000354fi
garciadeblas16304ba2016-05-11 14:47:39 +0200355
356#configure arg-autocomplete for this user
357#in case of minimal instalation this package is not installed by default
358[[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
359#su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
360su $SUDO_USER -c 'activate-global-python-argcomplete --user'
tiernoc50e5da2016-07-06 17:49:45 +0200361if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200362then
363 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
tiernoc50e5da2016-07-06 17:49:45 +0200364 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200365fi
366
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +0300367if [ -z "$NO_DB" ]; then
tierno80fde982017-04-26 14:33:25 +0200368 echo -e "\n"\
tierno070e95f2017-05-05 15:55:13 +0200369 "#################################################################\n"\
370 "##### INSTALL DATABASE SERVER #####\n"\
tierno80fde982017-04-26 14:33:25 +0200371 "#################################################################"
tierno45a52852016-08-26 14:39:42 +0200372
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +0300373 if [ -n "$QUIET_MODE" ]; then
374 DB_QUIET='-q'
375 fi
tierno070e95f2017-05-05 15:55:13 +0200376 ${BASEFOLDER}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} $DB_QUIET $DB_FORCE_UPDATE || exit 1
tierno80fde982017-04-26 14:33:25 +0200377 echo -e "\n"\
tierno070e95f2017-05-05 15:55:13 +0200378 "#################################################################\n"\
379 "##### CREATE AND INIT MANO_VIM DATABASE #####\n"\
tierno80fde982017-04-26 14:33:25 +0200380 "#################################################################"
381 # Install mano_vim_db after setup
382 ${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db --no-install-packages $DB_QUIET $DB_FORCE_UPDATE || exit 1
383fi # [ -z "$NO_DB" ]
tierno45a52852016-08-26 14:39:42 +0200384
tierno26777652016-11-15 17:33:13 +0000385if [[ -n "$INSTALL_AS_A_SERVICE" ]]
tierno45a52852016-08-26 14:39:42 +0200386then
tierno80fde982017-04-26 14:33:25 +0200387 echo -e "\n"\
tierno070e95f2017-05-05 15:55:13 +0200388 "#################################################################\n"\
389 "##### CONFIGURE OPENMANO SERVICE #####\n"\
tierno80fde982017-04-26 14:33:25 +0200390 "#################################################################"
tierno45a52852016-08-26 14:39:42 +0200391
tierno070e95f2017-05-05 15:55:13 +0200392 ${BASEFOLDER}/scripts/install-openmano-service.sh -f ${BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
393 # rm -rf ${BASEFOLDER}
tierno80fde982017-04-26 14:33:25 +0200394 # alias service-openmano="service openmano"
395 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
tierno45a52852016-08-26 14:39:42 +0200396 echo
tierno26777652016-11-15 17:33:13 +0000397 echo "Done! installed at /opt/openmano"
garciadeblasde590c02017-04-24 13:17:01 +0200398 echo " Manage server with 'sudo service osm-ro start|stop|status|...' "
tierno45a52852016-08-26 14:39:42 +0200399else
tierno45a52852016-08-26 14:39:42 +0200400 echo
401 echo "Done! you may need to logout and login again for loading client configuration"
tierno070e95f2017-05-05 15:55:13 +0200402 echo " Run './${BASEFOLDER}/scripts/service-openmano start' for starting openmano in a screen"
tierno45a52852016-08-26 14:39:42 +0200403fi